This is a very crude C shell script which manipulates a directory of PDB
files and calls a Fortran program format for converting entries. If
you make any improvements let have them please!

Comments, questions system@cuhhca.hhmi.columbia.edu

         /Phil Bourne

Contents
--------

*,f            Source code for the format convertor
brookhaven     Simple C shell script.. read it for details
makefile       builds format - the format convertor

c#subroutine rdhead     srs     v1.1     jan 1981
	subroutine rdhead(iun,ifmt)
c
c	This routine reads the header or title record
c	from a formatted coordinate file. The formats
c	accomidated by the program are listed in the
c	comment section for FTCHUZ.
c
c
c	v1.1: error handling prevents bomb if title
c		cards missing. Note this may result in
c		loss of up to three coordinate records.
c		for a diamond file
c
c
c	the file is assumed to exist on unit IUN.
c
c****************************************************
c&
	character*1 ijunk
	character*80 title
	character*4 junk
c
	go to (100,10,20,100,100,100),ifmt
c 
c ****  Kraut format; read the CELL and GRID cards
10	read(iun,6,end=500,err=12) junk
	read(iun,6,end=500,err=12) junk
	go to 100
12	rewind iun
	go to 100
c ****  Diamond format; read a title
20	print *,' '
	print *,'Title of Diamond formatted Coordinate file:'
	read(iun,6,end=500,err=21)iijunk
21	read(iun,1,end=500,err=22)title
22	read(iun,6,end=500,err=23)iijunk
	print *,title
23	print *,'No title record'
c ****  header structure unknown or header absent
100	return
c
500	print 3, ifmt,iun
	stop
1	format(a80)
3	format(1x,'unexpected eof on header read',/,
     *  1x,'format type:',i5,/,1x,'unit:',i5,//)
6	format(a1)
66	format(i5)
	end

c#subroutine ftchuz     srs     v1.0     jan, 1981
	subroutine ftchuz(ifmt)
c
c	this routine asks the user for a coordinate
c	file format designator. The following alt-
c	ernatives are available:
c
c	Protein Data Bank (PDB) ..... ifmt=1
c	Kraut ....................... ifmt=2
c	Diamond (as used by FRODO) .. ifmt=3
c	Hendrickson ................. ifmt=4
c	Shapley Moldels (write only). ifmt=5
c	From Hendrickson (read only)  ifmt=6
c
c	If it becomes desirable to extend this list
c	of formats, the programs HEADR, RDREC, WTREC,
c	TAILR must also be modified to accomidate
c	the new format. This should be trivial in 
c	most cases.
c
c******************************************************
c&
10	print *,' '
    	print *, ' Input/output format types'
        print *, ' available formats are:'
        print *, ' BROOKHAVEN.............. 1'
        print *, ' KRAUT .................. 2'
        print *, ' DIAMOND ................ 3'
        print *, ' HENDRICKSON ............ 4'
	print *, ' SHAPLEY    (write only)  5'
	print *, ' FROM HENDRICKSON (read only) 6'
	print *, ' '
        print *, ' Please choose a number to decribe input or output'
	read (5,5000) ifmt
5000	format(i5)
	if( ifmt .le. 0) stop
	if( ifmt .gt. 6) then
		print *,' never heard of it'
		go to 10
	else
	return
	endif
	end

c#subroutine wtrec     srs     v1.0     jan 81
	subroutine wtrec(iun,ifmt,icount,in_an,in_rn,nr,x,d)
c
c	Write a coordinate record for a protein data file
c	Arguments as as follows:
c
c	IUN ... unit number for write
c	IFMT .. format selection; Available formats
c		are documented in comments to 
c		FTCHUZ.
c	ICOUNT. record counter. Set by calling routine
c	AN .... atom name; a character*4 variable
c	RN .... residue name; as above
c	NR .... residue number
c	X ..... x,y,z for the atom
c	D ..... up to two associated variables
c
c  2/9/88 Bug fix for Hendrickson write [PEB]
c**********************************************************
c&
	dimension x(3), d(2)
	character*4 in_an,in_rn,an,rn,oldrna,blank4
	integer oldrnu
	integer idw(5)
	character*1 atmtyp(5)
	character*1 onelet
	character*2 blank2
c
c
	data atmtyp/'C','N','O','P','S'/
	data idw/1,2,3,4,5/
	data blank4,blank2/'    ','  '/
c  *** forget case conversion.. PDB always uppercase [PEB 6/23/87]
c	call str$upcase(an,in_an)
        an = in_an
c	call str$upcase(rn,in_rn)
        rn = in_rn
	ichain = 1
	go to (10,20,30,40,50),ifmt
c
c ***   PDB format
10	write(iun,1)icount,an,rn,nr,x,d,blank2,blank4,blank4,blank4
	return
c
c ***   KRAUT format
20 	if( nr .ne. oldrnu) then
	oldrna = rn
	oldrnu = nr
	write(iun,2)rn,nr
	endif
	write(iun,3)an,x,d(1),an,nr
	return
c
c ***	DIAMOND
30	do 35 i=1,5
	if (an(1:1) .eq. atmtyp(i))go to 36
35	continue
	print *,'WTREC BOMB; unknown atom type for Diamond file: ',atom
	stop
36	itype = idw(i)
	write(iun,4)x,d(1),itype,nr,icount,d(2),rn,an
	return
c
c ***   HENDRICKSON
40	call encode(rn,onelet)
	d(1) = 1.00         ! set occupancy to 1.0 [peb]
        write(iun,6)ichain,rn,onelet,nr,an,x,d(2),d(1)   ![peb]
	return
c
c **	SHAPELEY MODEL
c
50	if( an .ne. 'CA ' ) return
	ncount = ncount + 1
	write(iun,5)an,rn,ncount,x
	return
1	format('ATOM',2x,i5,2x,2a4,i5,4x,3f8.3,2f6.2,a2,3a4)
2	format('RESIDU',2x,a4,i4)
3	format('ATOMG',4x,a4,3f8.3,f6.2,a4,i4)
4	format(4f10.5,3i5,f9.4,1x,a4,6x,a4)
5	format(1x,a2,2x,a3,2x,i4,5x,3(f7.3,1x))
6	format(i2,1x,a3,1x,a1,i3,a4,5f10.5)
	end

c#encode.f     srs     v1.0     nov 81
c
	subroutine encode(name,char)
c
c	encode three letter amino acid code
c	into one letter code
c
c	arguments:
c
c	CHAR: one letter code ; character*1
c
c	NAME: three letter code ; character*4
c
c&*******************************************
c
	character*4 name,big1(25),big2(25)
	character*1 char,small(26)
	data big1/'ALA','VAL','GLY','LEU','ILE',
     *		 'CYS','MET','PHE','TRP','TYR',
     *		 'PRO','HIS','ASN','GLN','ASP',
     *		 'GLU','LYS','ARG','THR','SER',
     *		 'PLP','SRP','WAT','GLC','SOL'/
	data big2/'ala','val','gly','leu','ile',
     *		 'cys','met','phe','trp','tyr',
     *		 'pro','his','asn','gln','asp',
     *		 'glu','lys','arg','thr','ser',
     *		 'plp','srp','wat','glc','sol'/
	data small/'A','V','G','L','I','C','M','F','W','Y',
     *		   'P','H','N','Q','D','E','K','R','T','S',
     *		   'Z','X','O','U','B','?'/
	do 10 i=1,25
	if (name .eq. big1(i) .or. name .eq. big2(i)) go to 20
10	continue
	char = small(25)
	return
20	char = small(i)
	return
	end

c#reformat.f     srs     v1.0     apr 81
c
c	program to read a coordinate file in 
c	one format and output in another.
c
c	the available formats are listed by
c	the program and are documented in 
c	subroutine FTCHUZ.
c
c	Subroutines called:
c	FTCHUZ
c	RDHEAD
c	WTHEAD
c	RDREC
c	WTREC
c	WTTAIL
c	ENCODE
c	RECODE
c
c&************************************************
c
	dimension x(3),d(2)
        character*20 dir
	character*4 an,rn,code,ext 
	character*28 filena
c
	lun1 = 1
	lun2 = 2
	icount = 0
c
	rewind lun1
	call ftchuz(in)
	call rdhead(lun1,in)
	rewind lun2
	call ftchuz(iout)
	call wthead(lun2,iout)
c
10	call rdrec(lun1,in,iend,an,rn,nr,x,d)
	if (iend .eq. 1) go to 50
	icount = icount + 1
	call wtrec(lun2,iout,icount,an,rn,nr,x,d)
	go to 10
c
50	call wttail(lun2,iout)
	print *,icount,' Records translated.'
	stop
	end

c#rdrec.f     srs     v1.2     apr 81  
	subroutine rdrec(iun,ifmt,iend,an,rn,nr,x,d)
c
c	This routine reads one atom record from a
c	formatted coordinate file. The format types 
c	available are listed in the comment section of
c	FTCHUZ.
c
c	v1.2 : input reads are done in free format to
c		provide a wider compatabiliy with variants
c		of the format types.
c
c	Arguments are as follows:
c
c	IUN ... logical unit number for read
c	IEND .. end of file flag. Usually IEND = 0
c		but set to 1 if end of file or
c		terminator record encountered.
c	IFMT .. format designator. see FTCHUZ
c	AN .... atom name; a character*4 variable
c	RN .... residue name; character*4
c	NR .... residue number
c	X ..... x,y,z ; atomic coordinate
c	D ..... up to two associated parameters
c
c*******************************************************
c&
	dimension x(3),d(2)
	character*4 an,rn,oldrna,atom,resu,last,atom2,last1
	character*1 onelet
	character*80 list
	character*4 alist
	integer oldrnu
	equivalence (alist,list)
	data atom,resu,last,last1/'atom','RESI','end','END'/
	data atom2/'ATOM'/
c
	d(1) = 0.0
	d(2) = 1.0
	iend = 0
c
	go to (10,20,30,40,50,60),ifmt
c
c ****  PDB format
10	read(iun,1,end=500,err=10)oldrna,in,an,rn,nr,x,d
	if( oldrna .ne. atom .and.
     .      oldrna .ne. 'ATOM' .and.
     .      oldrna .ne. 'ATOM2' .and.
     .	    oldrna .ne. atom2 .and.
     .	    oldrna .ne. 'heta' .and.
     .      oldrna .ne. 'HETA') go to 10
	return
c ****  KRAUT format
20	read(iun,3,end=500)list
	if( alist .eq. resu) go to 25
	if( alist .eq. last) go to 500
	if( alist .eq. last1) go to 500
	if( alist .ne. atom2) go to 600
	read(list,4)an,x,d(1),an,nr
	return
25	read(list,5)rn,nr
	go to 20
c ****  DIAMOND format
30	read(iun,6,end=500)x,d(1),idw,nr,no,d(2),rn,an
	if (no .le. 0) go to 500
c
	return
c ****  HENDRICKSON format
40	read(iun,7,end=500)ichain,rn,onelet,nr,an,x,d(2),d(1)
	if(nr .eq. 999) go to 500
	return
c
c ****  FROM HENDRICKSON format
60 	read(iun,8,end=500) onelet,nr,an,x,d(2),d(1)      
	if(onelet.eq.' ') go to 500
	call recode(rn,onelet)
	if(an.eq.'OT ') an='OXT'
	return
c
500	iend = 1
	print *,'end of file encountered'
	return
c
600	print *,'(" wild card found in KRAUT file:",a4)', alist
	stop
700	print *,'(" wild card found in PDB file:",a4)', oldrna
	stop
c
50	print *,' SHAPLEY fmt is not supposed to be read '
	stop
c
1	format(a4,2x,i5,2x,2a4,1x,i4,4x,3f8.3,2f6.2)
3	format(a80)
4	format(9x,a4,3f8.4,f6.2,a4,i4)
5	format(8x,a4,i4)
6	format(4f10.5,3i5,f9.4,1x,a4,6x,a4)
7	format(i2,1x,a3,1x,a1,i3,a4,5f10.5)
8	format(7x,a1,i3,a4,5f10.3)
	end

c#subroutine wttail     srs     v1.0     jan 1981
	subroutine wttail(iun,ifmt)
c
c	Write an end of file record for a coordinate
c	file. Format types described in FTCHUZ. 
c
c	IUN ... logical unit number of the file
c	IFMT .. format designator set by FTCHUZ
c
c*******************************************************
c&
	no = -1
	go to (10,20,30,40),ifmt
c
c ***   PDB file; no end of file record
10	return
c
c ***   KRAUT file
20	write(iun,1)
	return
c
c ***   DIAMOND file
30	write(iun,2)no
	return
c
c ***   HENDRICKSON file
40	return
c
1	format('END')
2	format(45x,i5)
3	format(8x,'999')
c
	end

c#subroutine wthead     srs     v1.0     jan 1981
	subroutine wthead(iun,ifmt)
c
c	This routine writes a header record or
c	title card for a protein coordinate file.
c	the format type is indicated by IFMT, the
c	logical unit by IUN. The formats available
c	are listed in FTCHUZ.
c
c****************************************************
c&
	character*80 title
	dimension cell(6),igrid(3)
	data cell,igrid/3*1.0000,3*90.00000,3*1/
c
	go to (10,20,30,40,40,40),ifmt
c
c
c  ***	PDB format ... no header record
10	return
c  ***  KRAUT format .. insert CELL and GRID cards
20	write(iun,1)cell
	write(iun,2)igrid
	return
c  ***  DIAMOND  .... insert title card 
30	print *,' '
	print *,'Enter title for Diamond formatted Coordinate file:'
	read (5,5000)title
5000	format (a80)
	write(iun,3)title
	return
c  ***  HENDRICKSON  ... ditto
40	return
c
1	format('CELL',9x,3f7.3,3f9.5)
2	format('GRID',9x,3i4)
3	format('0',/,a80,/,'1')
c
	end
